PlayerCivilianStealth = PlayerCivilianStealth or class(PlayerCivilian)

Hooks:PostHook(PlayerCivilianStealth, "_check_action_duck", "CheckDuck", function(self, t, input)
	if input.btn_duck_release or input.btn_duck_press then
		PlayerStandard._check_action_duck(self, t, input)
	end
end)

Hooks:PostHook(PlayerCivilianStealth, "_check_action_interact", "CheckInteract", function(self)
	return true
end)

function PlayerCivilianStealth:_check_action_jump(t, input)
	if input.btn_jump_press then
		PlayerStandard._check_action_jump(self, t, input)
	end
end

function PlayerCivilianStealth:_check_action_run(t, input)
	if self._setting_hold_to_run and input.btn_run_release or self._running and not self._move_dir then
		self._running_wanted = false

		if self._running then
			self:_end_action_running(t)
			self:set_running(false)
		end
	elseif not self._setting_hold_to_run and input.btn_run_release and not self._move_dir then
		self._running_wanted = false
		
		if self._running then
			self:_end_action_running(t)
			self:set_running(false)
		end
	elseif input.btn_run_press or self._running_wanted then
		if not self._running or self._end_running_expire_t then
			self:_start_action_running(t)
		elseif self._running and not self._setting_hold_to_run then
			self:_end_action_running(t)
			self:set_running(false)
		end
	end
end

function PlayerCivilianStealth:_start_action_running(t)
	if not self._move_dir then
		self._running_wanted = true

		return
	end

	if self:on_ladder() or self:_on_zipline() then
		return
	end

	if self._state_data.ducking and not self:_can_stand() then
		self._running_wanted = true

		return
	end

	if not self:_can_run_directional() then
		return
	end

	self._running_wanted = false

	if managers.player:get_player_rule("no_run") then
		return
	end

	if not self._unit:movement():is_above_stamina_threshold() then
		return
	end

	if (not self._state_data.shake_player_start_running or not self._ext_camera:shaker():is_playing(self._state_data.shake_player_start_running)) and managers.user:get_setting("use_headbob") then
		self._state_data.shake_player_start_running = self._ext_camera:play_shaker("player_start_running", 0.75)
	end

	self:set_running(true)

	self._end_running_expire_t = nil
	self._start_running_t = t
	self._play_stop_running_anim = nil
	
	self:_interupt_action_reload(t)
	self:_interupt_action_steelsight(t)
	self:_interupt_action_ducking(t)
end

function PlayerCivilianStealth:_end_action_running(t)
	if not self._end_running_expire_t then
		self._end_running_expire_t = t + 0.4
	end
end

function PlayerCivilianStealth:_upd_attention()
	PlayerStandard._upd_attention(self)
end

function PlayerCivilianStealth:interaction_blocked()
	return false
end

function PlayerCivilianStealth:bleed_out_blocked()
	return true
end

Hooks:PostHook(PlayerCivilianStealth, "enter", "fix_detection", function(self)
	self._show_casing_t = nil
	self:_upd_attention()
end)

PlayerCivilianTied = PlayerCivilianTied or class(PlayerCivilian)

function PlayerCivilianTied:_get_max_walk_speed()
	return 0
end

function PlayerCivilianTied:_get_walk_headbob()
	return 0
end

function PlayerCivilianTied:interaction_blocked()
	return true
end

function PlayerCivilianTied:_upd_attention()
	self._ext_movement:set_attention_settings({"pl_civilian"})
end

function PlayerCivilianTied:_update_movement(t, dt)
end

Hooks:PostHook(PlayerCivilianTied, "enter", "on_enter_state", function(self)
	self._show_casing_t = nil
	self:_upd_attention()
	
	self._unit:camera():camera_unit():base():set_target_tilt(0)
	self._unit:camera():camera_unit():base():set_limits(135, nil)
	self._unit:camera():play_redirect(self._ids_cuffed)
	
	self:_interupt_action_running(managers.player:player_timer():time())
	
	self._state_data.ducking = true

	self:_stance_entered(true)
	self:_update_crosshair_offset()
	self._unit:kill_mover()
	
	self:_activate_mover(Idstring("duck"))
end)

Hooks:PostHook(PlayerCivilianTied, "exit", "on_exit_state", function(self)
	self._unit:camera():camera_unit():base():remove_limits()
	self._unit:camera():camera_unit():base():anim_clbk_unspawn_handcuffs()
	self._unit:camera():play_redirect(self._ids_escape)
	PlayerStandard.say_line(self, "s21x_sin")
	
	if not self:_can_stand() then
		return
	end

	self._state_data.ducking = false

	self:_stance_entered()
	self:_update_crosshair_offset()
	self._unit:kill_mover()
	
	self:_activate_mover(Idstring("stand"))
end)

Hooks:PostHook(PlayerCivilianTied, "init", "init_state", function(self)
	self._ids_escape = Idstring("escape")
	self._ids_cuffed = Idstring("cuffed")
end)