local level_id = Global.level_data and Global.level_data.level_id or ""
local difficulty = Global.game_settings and Global.game_settings.difficulty or "normal"

local valid_levels = {
	["the_shootout"] = true,
	["playashostage"] = true,
	["heat_escape"] = true,
	["highsecurity_lvl"] = true
}

if not valid_levels[level_id] then return end

-- this code is extemely hacky, be warned

-- Localize globals
local math = math
local log = log
local Hooks = Hooks
local managers = managers

if RequiredScript == "lib/units/enemies/cop/logics/coplogicidle" then

	local _chk_relocate = Hooks:GetFunction(CopLogicIdle, "_chk_relocate")
	Hooks:OverrideFunction(CopLogicIdle, "_chk_relocate", function(data,...)
		if data.objective and data.objective.type == "defend_area" and (not data.objective.grp_objective or data.objective.grp_objective.type ~= "retire") then
			local area = data.objective.area

			if area and not next(area.criminal.units) and (not data.attention_obj or AIAttentionObject.REACT_AIM > data.attention_obj.reaction) then
				local records = managers.groupai:state():all_char_criminals()
				local found_areas = {
					[area] = true
				}
				local areas_to_search = {
					area
				}
				local target_area = nil

				while next(areas_to_search) do
					local current_area = table.remove(areas_to_search)

					for criminal_key, _ in pairs(current_area.criminal.units) do
						if records[criminal_key] then
							local status = records[criminal_key].status

							if not status or status == "electrified" then
								target_area = current_area

								break
							end
						end
					end

					for _, n_area in pairs(current_area.neighbours) do
						if not found_areas[n_area] then
							found_areas[n_area] = true

							table.insert(areas_to_search, n_area)
						end
					end
				end

				if target_area then
					data.objective.in_place = nil
					data.objective.nav_seg = next(target_area.nav_segs)
					data.objective.path_data = {
						{
							data.objective.nav_seg
						}
					}

					data.logic._exit(data.unit, "travel")

					return true
				end
			end
		else
			return _chk_relocate(data,...)
		end
	end)

end

if RequiredScript == "lib/units/enemies/cop/copbase" then

	-- Randomizes enemy arsenal
	Hooks:PostHook(CopBase, "default_weapon_name", "force_weapon_loadout", function(self, selection_name)
		local access = tweak_data.character[self._unit:base()._tweak_table].access

		if self._unit:name():key() == Idstring("units/payday2/characters/ene_cop_2/ene_cop_2"):key() then
			-- Bronco cops just wield a glock now
			self._default_weapon_id = "c45"
		elseif access == "security" then
			self._default_weapon_id = "c45"
		end
	end)
	
	local mercenaries = {
		[Idstring("units/pd2_dlc_mad/characters/ene_akan_fbi_heavy_g36/ene_akan_fbi_heavy_g36"):key()] = true,
		[Idstring("units/pd2_dlc_mad/characters/ene_akan_fbi_swat_ak47_ass/ene_akan_fbi_swat_ak47_ass"):key()] = true,
		[Idstring("units/pd2_dlc_mad/characters/ene_akan_fbi_swat_dw_ak47_ass/ene_akan_fbi_swat_dw_ak47_ass"):key()] = true,
		[Idstring("units/pd2_dlc_mad/characters/ene_akan_fbi_swat_dw_r870/ene_akan_fbi_swat_dw_r870"):key()] = true,
		[Idstring("units/pd2_dlc_mad/characters/ene_akan_fbi_swat_r870/ene_akan_fbi_swat_r870"):key()] = true,
		[Idstring("units/pd2_dlc_mad/characters/ene_akan_cs_cop_ak47_ass/ene_akan_cs_cop_ak47_ass"):key()] = true,
		[Idstring("units/pd2_dlc_mad/characters/ene_akan_cs_cop_akmsu_smg/ene_akan_cs_cop_akmsu_smg"):key()] = true,
		[Idstring("units/pd2_dlc_mad/characters/ene_akan_cs_cop_asval_smg/ene_akan_cs_cop_asval_smg"):key()] = true,
		[Idstring("units/pd2_dlc_mad/characters/ene_akan_cs_cop_r870/ene_akan_cs_cop_r870"):key()] = true,
		[Idstring("units/pd2_dlc_mad/characters/ene_akan_cs_heavy_ak47_ass/ene_akan_cs_heavy_ak47_ass"):key()] = true,
		[Idstring("units/pd2_dlc_mad/characters/ene_akan_cs_swat_ak47_ass/ene_akan_cs_swat_ak47_ass"):key()] = true,
		[Idstring("units/pd2_dlc_mad/characters/ene_akan_cs_swat_r870/ene_akan_cs_swat_r870"):key()] = true,
		[Idstring("units/pd2_dlc_mad/characters/ene_akan_cs_swat_sniper_svd_snp/ene_akan_cs_swat_sniper_svd_snp"):key()] = true,
		[Idstring("units/pd2_dlc_mad/characters/ene_akan_medic_ak47_ass/ene_akan_medic_ak47_ass"):key()] = true,
		[Idstring("units/pd2_dlc_mad/characters/ene_akan_medic_r870/ene_akan_medic_r870"):key()] = true,
		[Idstring("units/pd2_dlc_mad/characters/ene_akan_fbi_spooc_asval_smg/ene_akan_fbi_spooc_asval_smg"):key()] = true,
		[Idstring("units/pd2_dlc_mad/characters/ene_akan_fbi_tank_r870/ene_akan_fbi_tank_r870"):key()] = true,
		[Idstring("units/pd2_dlc_mad/characters/ene_akan_fbi_tank_rpk_lmg/ene_akan_fbi_tank_rpk_lmg"):key()] = true,
		[Idstring("units/pd2_dlc_mad/characters/ene_akan_fbi_tank_saiga/ene_akan_fbi_tank_saiga"):key()] = true,
		[Idstring("units/pd2_dlc_mad/characters/ene_akan_cs_tazer_ak47_ass/ene_akan_cs_tazer_ak47_ass"):key()] = true,
		[Idstring("units/pd2_dlc_mad/characters/ene_akan_medic_ak47_ass/ene_akan_medic_ak47_ass"):key()] = true,
		[Idstring("units/pd2_dlc_mad/characters/ene_akan_medic_r870/ene_akan_medic_r870"):key()] = true,
	}
	
	local non_mercs = {
		[Idstring("units/payday2/characters/ene_city_swat_1/ene_city_swat_1"):key()] = true,
		[Idstring("units/payday2/characters/ene_city_swat_2/ene_city_swat_2"):key()] = true,
		[Idstring("units/payday2/characters/ene_city_swat_3/ene_city_swat_3"):key()] = true,
		[Idstring("units/payday2/characters/ene_murkywater_1/ene_murkywater_1"):key()] = true,
		[Idstring("units/payday2/characters/ene_murkywater_2/ene_murkywater_2"):key()] = true,
		[Idstring("units/payday2/characters/ene_cop_1/ene_cop_1"):key()] = true,
		[Idstring("units/payday2/characters/ene_cop_2/ene_cop_2"):key()] = true,
		[Idstring("units/payday2/characters/ene_cop_3/ene_cop_3"):key()] = true,
		[Idstring("units/payday2/characters/ene_cop_4/ene_cop_4"):key()] = true,
		[Idstring("units/payday2/characters/ene_security_1/ene_security_1"):key()] = true,
		[Idstring("units/payday2/characters/ene_security_2/ene_security_2"):key()] = true,
		[Idstring("units/payday2/characters/ene_security_3/ene_security_3"):key()] = true,
		[Idstring("units/payday2/characters/ene_swat_1/ene_swat_1"):key()] = true,
		[Idstring("units/payday2/characters/ene_swat_2/ene_swat_2"):key()] = true,
		[Idstring("units/payday2/characters/ene_fbi_1/ene_fbi_1"):key()] = true,
		[Idstring("units/payday2/characters/ene_fbi_2/ene_fbi_2"):key()] = true,
		[Idstring("units/payday2/characters/ene_fbi_3/ene_fbi_3"):key()] = true,
		[Idstring("units/payday2/characters/ene_fbi_boss_1/ene_fbi_boss_1"):key()] = true,
		[Idstring("units/payday2/characters/ene_fbi_heavy_1/ene_fbi_heavy_1"):key()] = true,
		[Idstring("units/payday2/characters/ene_fbi_office_1/ene_fbi_office_1"):key()] = true,
		[Idstring("units/payday2/characters/ene_fbi_office_2/ene_fbi_office_2"):key()] = true,
		[Idstring("units/payday2/characters/ene_fbi_office_3/ene_fbi_office_3"):key()] = true,
		[Idstring("units/payday2/characters/ene_fbi_office_4/ene_fbi_office_4"):key()] = true,
		[Idstring("units/payday2/characters/ene_fbi_swat_1/ene_fbi_swat_1"):key()] = true,
		[Idstring("units/payday2/characters/ene_fbi_swat_2/ene_fbi_swat_2"):key()] = true,
		[Idstring("units/payday2/characters/ene_swat_heavy_1/ene_swat_heavy_1"):key()] = true,
		[Idstring("units/payday2/characters/ene_medic_r870/ene_medic_r870"):key()] = true,
		[Idstring("units/payday2/characters/ene_medic_m4/ene_medic_m4"):key()] = true,
		[Idstring("units/payday2/characters/ene_city_heavy_r870/ene_city_heavy_r870"):key()] = true,
		[Idstring("units/payday2/characters/ene_city_heavy_g36/ene_city_heavy_g36"):key()] = true,
	}
	
	-- Change speeches
	Hooks:PostHook(CopBase, "init", "_change_speech_prefix", function(self, unit)
		if mercenaries[self._unit:name():key()] then
			if self:has_tag("tank") then
				self._char_tweak.speech_prefix_p1 = "rbdz"
			elseif self:has_tag("taser") then
				self._char_tweak.speech_prefix_p1 = "rtsr"
			elseif self:has_tag("spooc") then
				self._char_tweak.speech_prefix_p1 = "rclk"
			elseif self:has_tag("medic") then
				self._char_tweak.speech_prefix_p1 = "rmdc"
			else
				self._char_tweak.speech_prefix_p1 = "r"
			end
			self._char_tweak.rescue_hostages = level_id == "highsecurity_lvl"
			self._char_tweak.no_arrest = true
		elseif non_mercs[self._unit:name():key()] then
			if self:has_tag("tank") then
				self._char_tweak.speech_prefix_p1 = "bdz"
			elseif self:has_tag("taser") then
				self._char_tweak.speech_prefix_p1 = "tsr"
			elseif self:has_tag("spooc") then
				self._char_tweak.speech_prefix_p1 = "clk"
			elseif self:has_tag("medic") then
				self._char_tweak.speech_prefix_p1 = "mdc"
			else
				self._char_tweak.speech_prefix_p1 = "l"
			end
		end
	end)

end

-- Setting up attention data
if RequiredScript == "lib/tweak_data/attentiontweakdata" then

	-- Makes stealth possible during combat encounters since most of the time you be fighting scripted enemies
	Hooks:PostHook(AttentionTweakData, "init", "_upd_attention_data", function(self)
		for setting_name,setting in pairs(self.settings) do
			self.settings[setting_name].notice_requires_FOV = true
		end
	end)

end

-- No dominating jokers
-- They all scripted-spawns anyway, why would you? >:(
if RequiredScript == "lib/units/enemies/cop/logics/coplogicbase" then

	Hooks:OverrideFunction(CopLogicBase, "_evaluate_reason_to_surrender", function(data,my_data,aggressor_unit)
		return false
	end)

end

if RequiredScript == "lib/tweak_data/charactertweakdata" then
	Hooks:OverrideFunction(CharacterTweakData, "_multiply_all_hp", function()end)
	Hooks:OverrideFunction(CharacterTweakData, "_multiply_all_speeds", function()end)

	Hooks:PostHook(CharacterTweakData, "init", "_modify_enemy_characters", function(self)
		for _,enemy in pairs(self._enemy_list) do
			self[enemy].surrender = nil
		end
		
		self.security.no_arrest = true
		self.security.rescue_hostages = false
	end)
end

if RequiredScript == "lib/tweak_data/tweakdatapd2" then
	Hooks:PostHook( TweakData, "_setup_point_of_no_returns", "_street_escape_ponr", function(self)

		self.point_of_no_returns.reinforcement_arriving = {
			color = Color(1, 1, 0, 0),
			timer_flash_color = Color(1, 1, 0.8, 0.2), --Change this as you like
			attention_color = Color(1, 1, 1, 1), -- This too
			scale_box = true,
			text_id = "hud_assault_reinforcement_arriving"
		}
	end)
end

if RequiredScript == "lib/managers/blackmarketmanager" then
	function BlackMarketManager:forced_throwable()
		return "none"
	end

	function BlackMarketManager:forced_deployable()
		return "none"
	end

	function BlackMarketManager:forced_armor()
		return "level_1"
	end

	function BlackMarketManager:forced_body_bags()
		return 0
	end

	function BlackMarketManager:forced_character()
		return "russian"
	end

	function BlackMarketManager:forced_weapon(category)
		local lvl_id = managers.job:current_level_id()
		local cat_item = category == "primary" and "wpn_fps_pis_x_g17" or "wpn_fps_pis_g17" -- beretta

		local cached_data = self["_forced_" .. category .. "_data_cache"]

		if cached_data and cached_data.lvl_id == lvl_id then
			self:set_weapon_equipped_cache(category, cached_data.data)
			return cached_data.data
		end

		local blueprint = deep_clone(managers.weapon_factory:get_default_blueprint_by_factory_id(cat_item))

		local data = {
			equipped = true,
			factory_id = cat_item,
			blueprint = blueprint,
			weapon_id = managers.weapon_factory:get_weapon_id_by_factory_id(cat_item),
			global_values = {}
		}
		self["_forced_" .. category .. "_data_cache"] = {
			data = data,
			lvl_id = lvl_id
		}
		self:set_weapon_equipped_cache(category, data)
		return data
	end
end

if RequiredScript == "lib/units/beings/player/states/playerstandard" then
	--Hooks:OverrideFunction(PlayerStandard, "_play_equip_animation", function() end)
	--Hooks:OverrideFunction(PlayerStandard, "_play_unequip_animation", function() end)
end

if RequiredScript == "lib/tweak_data/interactiontweakdata" then
	if level_id == "highsecurity_lvl" then
		Hooks:PostHook(InteractionTweakData, "init", "_init_heist_interactions", function(self)
			for _,interaction in pairs(self) do
				if type(interaction) == "table" then
					interaction.can_interact_in_civilian = true
				end
			end
			
			self.open_door.can_interact_in_civilian = true
		end)
	end
	
	-- Prevent corpse disposal altogether
	Hooks:PostHook(InteractionTweakData, "init", "disable_bagging_up_corpses", function(self)
		self.corpse_dispose.interact_distance = 0
	end)
end

if RequiredScript == "lib/units/interactions/interactionext" then
	log("SUCCESSFULLY HOOKED " .. "lib/units/interactions/interactionext")
	
	Hooks:PostHook(IntimitateInteractionExt, "interact", "_custom_interactions", function(self, player)
		if self.tweak_data == "silent_takeout_interaction" and Network:is_server() then
			self._unit:character_damage():damage_mission({
				forced = true,
				damage = math.huge,
				col_ray = {
					attacker_unit = player,
					attack_dir = (self._unit:position() - player:position()):normalized()
				}
			})
			
			log("npc killed successfully") -- task failed successfully
		end
	end)
end

if RequiredScript == "lib/managers/dialogmanager" then
	if tweak_data.levels[level_id].suppress_dialog then
		Hooks:OverrideFunction(DialogManager, "queue_dialog", function() end)
	end
end

if RequiredScript == "lib/managers/moneymanager" then
	if tweak_data.levels[level_id].no_cleaner_costs then
		Hooks:OverrideFunction(MoneyManager, "get_civilian_deduction", function() return 0 end)
	end
end

if RequiredScript == "lib/managers/group_ai_states/groupaistatebase" then
	if tweak_data.levels[level_id].hostile_map then
		Hooks:PostHook(GroupAIStateBase, "init", "enable_chatter", function(self)
			self._radio_clbk = callback(self, self, "_radio_chatter_clbk")
			managers.enemy:add_delayed_clbk("_radio_chatter_clbk", self._radio_clbk, Application:time() + 30)
		end)
		
		Hooks:PostHook(GroupAIStateBase, "update", "force_peds_to_alert_stance", function(self, t, dt)
			if not Network:is_server() then return end
			if not self:whisper_mode() then return end
			
			for _,u_data in pairs(managers.enemy:all_enemies()) do
				if alive(u_data.unit) and u_data.unit:movement():cool() and u_data.unit:movement():stance_code() == 1 then
					u_data.unit:movement():_change_stance(2, true)
				end
			end
		end)
	end
end

if RequiredScript == "lib/managers/group_ai_states/groupaistatebesiege" then
	-- Assault config
	Hooks:PostHook(GroupAIStateBesiege, "init", "_setup_wave_data", function(self)
		tweak_data.group_ai.besiege.assault.fade_duration = 5
		tweak_data.group_ai.besiege.assault.build_duration = 35
		tweak_data.group_ai.smoke_grenade_lifetime = 7.5
		tweak_data.group_ai.flash_grenade.timer = 3

		-- Squad size, like how many enemies a single wave will have.
		if tweak_data.levels[level_id].must_clear_all_enemies_to_clear_wave then
			tweak_data.group_ai.besiege.assault.force = {
				4,
				6,
				8
			}
			tweak_data.group_ai.besiege.assault.force_pool = {
				6,
				12,
				15
			}
		else
			-- Increased spawn pool
			tweak_data.group_ai.besiege.assault.force = {
				12,
				12,
				15
			}
			tweak_data.group_ai.besiege.assault.force_pool = {
				100,
				150,
				230
			}
		end
		
		tweak_data.group_ai.besiege.assault.anticipation_duration = {
			{
				15,
				1
			}
		}
		tweak_data.group_ai.besiege.assault.sustain_duration_min = {
			120,
			120,
			120
		}
		tweak_data.group_ai.besiege.assault.sustain_duration_max = {
			120,
			120,
			120
		}
		tweak_data.group_ai.besiege.assault.sustain_duration_balance_mul = {
			1,
			1,
			1,
			1
		}
		tweak_data.group_ai.besiege.assault.delay = {
			25,
			25,
			25
		}
		
		tweak_data.group_ai.besiege.recon.groups = {}
		tweak_data.group_ai.besiege.recon.groups.custom = {0,0,0}
	end)

	if not tweak_data.levels[level_id].must_clear_all_enemies_to_clear_wave then return end

	-- Makes the assault only end if there no more enemies.
	Hooks:OverrideFunction(GroupAIStateBesiege, "_upd_assault_task", function(self)
		local task_data = self._task_data.assault

		if not task_data.active then
			return
		end

		local t = self._t

		self:_assign_recon_groups_to_retire()

		local force_pool = self:_get_difficulty_dependent_value(self._tweak_data.assault.force_pool) * self:_get_balancing_multiplier(self._tweak_data.assault.force_pool_balance_mul)
		local task_spawn_allowance = force_pool - (self._hunt_mode and 0 or task_data.force_spawned)

		if task_data.phase == "anticipation" then
			if task_spawn_allowance <= 0 then
				print("spawn_pool empty: -----------FADE-------------")

				task_data.phase = "fade"
				task_data.phase_end_t = t + self._tweak_data.assault.fade_duration
			elseif task_data.phase_end_t < t then -- Skip drama, just start the next wave
				self._assault_number = self._assault_number + 1

				managers.mission:call_global_event("start_assault")
				managers.hud:start_assault(self._assault_number)
				managers.groupai:dispatch_event("start_assault", self._assault_number)
				self:_set_rescue_state(false)

				task_data.phase = "build"
				task_data.phase_end_t = self._t + 0 -- self._tweak_data.assault.build_duration
				task_data.is_hesitating = nil

				self:set_assault_mode(true)
				managers.trade:set_trade_countdown(false)
			else
				managers.hud:check_anticipation_voice(task_data.phase_end_t - t)
				managers.hud:check_start_anticipation_music(task_data.phase_end_t - t)

				if task_data.is_hesitating and task_data.voice_delay < self._t then
					if self._hostage_headcount > 0 then
						local best_group = nil

						for _, group in pairs(self._groups) do
							if not best_group or group.objective.type == "reenforce_area" then
								best_group = group
							elseif best_group.objective.type ~= "reenforce_area" and group.objective.type ~= "retire" then
								best_group = group
							end
						end

						if best_group and self:_voice_delay_assault(best_group) then
							task_data.is_hesitating = nil
						end
					else
						task_data.is_hesitating = nil
					end
				end
			end
		elseif task_data.phase == "build" then
			if task_spawn_allowance <= 0 then
				task_data.phase = "fade"
				task_data.phase_end_t = t + self._tweak_data.assault.fade_duration
			elseif task_data.phase_end_t < t or self._drama_data.zone == "high" then
				local sustain_duration = math.lerp(self:_get_difficulty_dependent_value(self._tweak_data.assault.sustain_duration_min), self:_get_difficulty_dependent_value(self._tweak_data.assault.sustain_duration_max), math.random()) * self:_get_balancing_multiplier(self._tweak_data.assault.sustain_duration_balance_mul)

				managers.modifiers:run_func("OnEnterSustainPhase", sustain_duration)

				task_data.phase = "sustain"
				task_data.phase_end_t = t + sustain_duration
			end
		elseif task_data.phase == "sustain" then
			local end_t = self:assault_phase_end_time()
			task_spawn_allowance = managers.modifiers:modify_value("GroupAIStateBesiege:SustainSpawnAllowance", task_spawn_allowance, force_pool)

			if task_spawn_allowance <= 0 then
				task_data.phase = "fade"
				task_data.phase_end_t = t + self._tweak_data.assault.fade_duration
			elseif end_t < t and not self._hunt_mode then
				task_data.phase = "fade"
				task_data.phase_end_t = t + self._tweak_data.assault.fade_duration
			end
		else
			local end_assault = false
			local enemies_left = self:_count_police_force("assault")

			if not self._hunt_mode then
				local enemies_defeated = enemies_left <= 0

				if enemies_defeated then
					if not task_data.said_retreat then
						task_data.said_retreat = true

						self:_police_announce_retreat()
					elseif task_data.phase_end_t < t then
						local drama_pass = self._drama_data.amount < tweak_data.drama.assault_fade_end
						local engagement_pass = self:_count_criminals_engaged_force(11) <= 10

						if drama_pass and engagement_pass then
							end_assault = true
						end
					end
				end

				if task_data.force_end or end_assault then
					print("assault task clear")

					task_data.active = nil
					task_data.phase = nil
					task_data.said_retreat = nil
					task_data.force_end = nil
					local force_regroup = task_data.force_regroup
					task_data.force_regroup = nil

					if self._draw_drama then
						self._draw_drama.assault_hist[#self._draw_drama.assault_hist][2] = t
					end

					managers.mission:call_global_event("end_assault")
					self:_begin_regroup_task(force_regroup)

					return
				end
			end
		end

		if self._drama_data.amount <= tweak_data.drama.low then
			for criminal_key, criminal_data in pairs(self._player_criminals) do
				self:criminal_spotted(criminal_data.unit)

				for group_id, group in pairs(self._groups) do
					if group.objective.charge then
						for u_key, u_data in pairs(group.units) do
							u_data.unit:brain():clbk_group_member_attention_identified(nil, criminal_key)
						end
					end
				end
			end
		end

		local primary_target_area = task_data.target_areas[1]

		if self:is_area_safe_assault(primary_target_area) then
			local target_pos = primary_target_area.pos
			local nearest_area, nearest_dis = nil

			for criminal_key, criminal_data in pairs(self._player_criminals) do
				if not criminal_data.status then
					local dis = mvector3.distance_sq(target_pos, criminal_data.m_pos)

					if not nearest_dis or dis < nearest_dis then
						nearest_dis = dis
						nearest_area = self:get_area_from_nav_seg_id(criminal_data.tracker:nav_segment())
					end
				end
			end

			if nearest_area then
				primary_target_area = nearest_area
				task_data.target_areas[1] = nearest_area
			end
		end

		local nr_wanted = task_data.force - self:_count_police_force("assault")

		if task_data.phase == "anticipation" then
			nr_wanted = nr_wanted - 5
		end

		if nr_wanted > 0 and task_data.phase ~= "fade" then
			local used_event = nil

			if task_data.use_spawn_event and task_data.phase ~= "anticipation" then
				task_data.use_spawn_event = false

				if self:_try_use_task_spawn_event(t, primary_target_area, "assault") then
					used_event = true
				end
			end

			if not used_event then
				if next(self._spawning_groups) then
					-- Nothing
				else
					self:_check_spawn_timed_groups(primary_target_area, task_data)

					local spawn_group, spawn_group_type = self:_find_spawn_group_near_area(primary_target_area, self._tweak_data.assault.groups, nil, nil, nil)

					if spawn_group then
						local grp_objective = {
							attitude = "avoid",
							stance = "hos",
							pose = "crouch",
							type = "assault_area",
							area = spawn_group.area,
							coarse_path = {
								{
									spawn_group.area.pos_nav_seg,
									spawn_group.area.pos
								}
							}
						}

						self:_spawn_in_group(spawn_group, spawn_group_type, grp_objective, task_data)
					end
				end
			end
		end

		if task_data.phase ~= "anticipation" then
			if task_data.use_smoke_timer < t then
				task_data.use_smoke = true
			end

			self:detonate_queued_smoke_grenades()
		end

		self:_assign_enemy_groups_to_assault(task_data.phase)
	end)
end